#include <iostream>
using namespace std;
int main(){
    int t;
    cin>>t;
    for(int i=0;i<t;i++){
        int n,m,a,a1,a2,b2;
        bool s=true;
        cin>>n>>m>>a>>a1;
        int x = abs(a1-a);
        for(int i=2;i<n;i++){
            cin>>a2;
            if((a2-a)%x!=0){
                s=false;
            }
        }
        for(int i=0;i<m;i++){
            cin>>b2;
            if((a-b2)%x==0){
                s=false;
            }
        }
        if(s){
            cout<<1<<endl;
        }
        else{
            cout<<0<<endl;
        }
    }
}